Enumeration
  #MainWindow
  #FindWindow
  #ViewerWindow
  #HelpWindow
EndEnumeration
Enumeration
  #MainMenu
  #MainPopupMenu
EndEnumeration
Enumeration
  #MainMenu_New
  #MainMenu_Open
  #MainMenu_Save
  #MainMenu_SaveAs
  
  #MainMenu_Close
  #MainMenu_Quit
  
  
  #MainMenu_Undo
  #MainMenu_Redo
  
  #MainMenu_Cut
  #MainMenu_Copy
  #MainMenu_Paste
  
  #MainMenu_SelectAll
  
  #MainMenu_FindReplace
  #MainMenu_FindNext
  
  #MainMenu_Date
  #MainMenu_Header
  
  
  #MainMenu_Run
  #MainMenu_CreateTokenFile
  
  #MainMenu_RunInInstance
  #MainMenu_NewInstance
  #MainMenu_ClearOutput
  
  #MainMenu_OpenOperno
  
  
  #MainMenu_Font
  #MainMenu_ForegroundColor
  #MainMenu_BackgroundColor
  
  #MainMenu_EnableOutput
  
  
  #MainMenu_Viewer
  #MainMenu_FunctionPlotter
  #MainMenu_Naltor
  
  #MainMenu_GenerateHTML
  #MainMenu_ConfigureGenerator
  
  
  #MainMenu_Help
  #MainMenu_Info
  #MainMenu_Tutorial
EndEnumeration
Enumeration
  #Main_Panel
  #Main_Output
  #Main_Splitter
  
  #Find_ReplaceText
  #Find_ToFindText
  #Find_ToFind
  #Find_ToReplace
  #Find_CheckCaseSensitive
  #Find_CheckWholeWords
  #Find_DoReplaceAll
  #Find_DoReplace
  #Find_DoFind
  #Find_DoCancel
  
  #Viewer_Tree
EndEnumeration
Enumeration
  #MainFont
EndEnumeration



Procedure OpenMainWindow()
  LoadFont(#MainFont, IDE_Font, IDE_FontSize)
  
  OpenWindow(#MainWindow, #PB_Ignore, #PB_Ignore, 500, 400, "Operno Editor",  #PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_TitleBar|#PB_Window_MaximizeGadget|#PB_Window_MinimizeGadget|#PB_Window_Maximize)
    CreateMenu(#MainMenu, WindowID(#MainWindow))
      MenuTitle("File")
      MenuItem(#MainMenu_New, "New" + #T + "Ctrl+N")
      MenuItem(#MainMenu_Open, "Open...")
      MenuItem(#MainMenu_Save, "Save")
      MenuItem(#MainMenu_SaveAs, "Save as...")
      MenuBar()
      MenuItem(#MainMenu_Close, "Close" + #T + "Ctrl+W")
      MenuItem(#MainMenu_Quit, "Quit")
      MenuTitle("Edit")
      MenuItem(#MainMenu_Undo, "Undo" + #T + "Ctrl+Z")
      MenuItem(#MainMenu_Redo, "Redo" + #T + "Ctrl+Y")
      MenuBar()
      MenuItem(#MainMenu_Cut, "Cut" + #T + "Ctrl+X")
      MenuItem(#MainMenu_Copy, "Copy" + #T + "Ctrl+C")
      MenuItem(#MainMenu_Paste, "Paste" + #T + "Ctrl+P")
      MenuBar()
      MenuItem(#MainMenu_SelectAll, "Select all" + #T + "Ctrl+A")
      MenuBar()
      MenuItem(#MainMenu_FindReplace, "Find/Replace")
      MenuItem(#MainMenu_FindNext, "Find next")
      MenuBar()
      MenuItem(#MainMenu_Date, "Date")
      MenuItem(#MainMenu_Header, "Header")
      MenuTitle("Operno")
      MenuItem(#MainMenu_Run, "Run" + #T + "F9")
      MenuItem(#MainMenu_CreateTokenFile, "Create token file")
      MenuBar()
      MenuItem(#MainMenu_RunInInstance, "Run in instance" + #T + "F5")
      MenuItem(#MainMenu_NewInstance, "New instance")
      MenuItem(#MainMenu_ClearOutput, "Clear output")
      MenuBar()
      MenuItem(#MainMenu_OpenOperno, "Open")
      MenuTitle("Options")
      MenuItem(#MainMenu_Font, "Font...")
      MenuItem(#MainMenu_ForegroundColor, "Foreground color...")
      MenuItem(#MainMenu_BackgroundColor, "Background color...")
      MenuTitle("Extras")
      MenuItem(#MainMenu_Viewer, "Viewer" + #T + "F3")
      MenuItem(#MainMenu_FunctionPlotter, "Function plotter")
      MenuItem(#MainMenu_Naltor, "Naltor")
      MenuBar()
      MenuItem(#MainMenu_GenerateHTML, "Generate HTML file" + #T + "F2")
      MenuItem(#MainMenu_ConfigureGenerator, "Configure generator")
      MenuTitle("Help")
      MenuItem(#MainMenu_Help, "Help..." + #T + "F1")
      MenuItem(#MainMenu_Info, "Info")
      MenuItem(#MainMenu_Tutorial, "Tutorial")
    
    PanelGadget(#Main_Panel, 0, 0, 0, 0) : CloseGadgetList()
      Open()
    EditorGadget(#Main_Output, 0, 0, 0, 0, #PB_Editor_ReadOnly)
    SplitterGadget(#Main_Splitter, 0, 0, 540, 300, #Main_Panel, #Main_Output)
    
    SetGadgetFont(#Main_Output, FontID(#MainFont))
    SetGadgetColor(#Main_Output, #PB_Gadget_FrontColor, IDE_ForegroundColor)
    SetGadgetColor(#Main_Output, #PB_Gadget_BackColor, IDE_BackgroundColor)
    SetGadgetState(#Main_Splitter, 200)
    
    AddKeyboardShortcut(#MainWindow, #PB_Shortcut_N|#PB_Shortcut_Control, #MainMenu_New)
    AddKeyboardShortcut(#MainWindow, #PB_Shortcut_O|#PB_Shortcut_Control, #MainMenu_Open)
    AddKeyboardShortcut(#MainWindow, #PB_Shortcut_S|#PB_Shortcut_Control, #MainMenu_Save)
    AddKeyboardShortcut(#MainWindow, #PB_Shortcut_W|#PB_Shortcut_Control, #MainMenu_Close)
    AddKeyboardShortcut(#MainWindow, #PB_Shortcut_Z|#PB_Shortcut_Control, #MainMenu_Undo)
    AddKeyboardShortcut(#MainWindow, #PB_Shortcut_Y|#PB_Shortcut_Control, #MainMenu_Redo)
    AddKeyboardShortcut(#MainWindow, #PB_Shortcut_X|#PB_Shortcut_Control, #MainMenu_Cut)
    AddKeyboardShortcut(#MainWindow, #PB_Shortcut_C|#PB_Shortcut_Control, #MainMenu_Copy)
    AddKeyboardShortcut(#MainWindow, #PB_Shortcut_P|#PB_Shortcut_Control, #MainMenu_Paste)
    AddKeyboardShortcut(#MainWindow, #PB_Shortcut_A|#PB_Shortcut_Control, #MainMenu_SelectAll)
    AddKeyboardShortcut(#MainWindow, #PB_Shortcut_F9, #MainMenu_Run)
    AddKeyboardShortcut(#MainWindow, #PB_Shortcut_F5, #MainMenu_RunInInstance)
    AddKeyboardShortcut(#MainWindow, #PB_Shortcut_F1, #MainMenu_Help)
    AddKeyboardShortcut(#MainWindow, #PB_Shortcut_F2, #MainMenu_GenerateHTML)
    AddKeyboardShortcut(#MainWindow, #PB_Shortcut_F3, #MainMenu_Viewer)
    
    CreatePopupMenu(#MainPopupMenu)
      MenuItem(#MainMenu_Cut, "Cut" + #T + "Ctrl+X")
      MenuItem(#MainMenu_Copy, "Copy" + #T + "Ctrl+C")
      MenuItem(#MainMenu_Paste, "Paste" + #T + "Ctrl+P")
      MenuBar()
      MenuItem(#MainMenu_SelectAll, "Select all" + #T + "Ctrl+A")
      MenuBar()
      MenuItem(#MainMenu_Close, "Close" + #T + "Ctrl+W")
      
    EnableGadgetDrop(#Main_Panel, #PB_Drop_Files, #PB_Drag_Copy)
EndProcedure

Procedure OpenFindWindow()
  OpenWindow(#FindWindow, 257, 178, 350, 110, "Find/Replace",  #PB_Window_SystemMenu|#PB_Window_TitleBar, WindowID(#MainWindow))
    TextGadget(#Find_ReplaceText, 10, 30, 60, 20, "To replace:")
    TextGadget(#Find_ToFindText, 10, 10, 60, 20, "To find:")
    StringGadget(#Find_ToFind, 70, 10, 270, 20, "")
    StringGadget(#Find_ToReplace, 70, 30, 270, 20, "")
    CheckBoxGadget(#Find_CheckCaseSensitive, 10, 60, 100, 20, "Case sensitive")
    CheckBoxGadget(#Find_CheckWholeWords, 10, 80, 90, 20, "Whole words")
    ButtonGadget(#Find_DoReplaceAll, 230, 80, 110, 20, "Replace all")
    ButtonGadget(#Find_DoReplace, 110, 80, 110, 20, "Replace")
    ButtonGadget(#Find_DoFind, 110, 60, 110, 20, "Find")
    ButtonGadget(#Find_DoCancel, 230, 60, 110, 20, "Cancel")
EndProcedure

Procedure OpenViewerWindow()
  OpenWindow(#ViewerWindow, #PB_Any, #PB_Any, 280, 500, "Viewer",  #PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_TitleBar, WindowID(#MainWindow))
    TreeGadget(#Viewer_Tree, 0, 0, 280, 500)
    
  UpdateViewer()
EndProcedure

; IDE Options = PureBasic 4.41 (Windows - x86)
; CursorPosition = 133
; FirstLine = 101
; Folding = -
; EnableXP
; UseMainFile = Main.pb