;**************************************************************
;     Exceptions
;
; Autor: Josef Sniatecki
; Creation date: 03.04.2009
;**************************************************************
;   (c) 2009 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************


Procedure.i Error(Message.s)
  Error = #True
  If Message
    If ErrorMessage
      ErrorMessage + #N
    EndIf
    ErrorMessage + Message
  EndIf
EndProcedure
Procedure.i CheckTruncation(Decrement.i)
  If Truncation > 0
    Truncation - Decrement
  EndIf
EndProcedure
Procedure.i FatalErrorCallback()
  MessageRequester("Operno", "Error: " + ErrorMessage())
  Error      = #True
  Truncation = #Truncation_End
EndProcedure

; IDE Options = PureBasic 4.41 (Windows - x86)
; CursorPosition = 34
; FirstLine = 6
; Folding = -
; EnableXP
; CompileSourceDirectory